#!/usr/bin/perl
## printconf-backend - A Python Printing configuration utility
## Copyright (C) 2000 Red Hat, Inc.
## Copyright (C) 2000 Crutcher Dunnavant <crutcher@redhat.com>,

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


# This program eats perl foomatic files, and reprints their options,
# so that printconf can eat them easily.

$foomatic_dir = '/usr/share/printconf/foomatic';
$poid = shift;
$driver = shift;

undef $/;

open (IN, $foomatic_dir . "/data/$driver-$poid.foo") || 
open (IN, $foomatic_dir . "/rh-data/$driver-$poid.foo") || 
exit 1;
eval (<IN>) or exit 1;
close (IN);
$printer = $VAR1;

print '{';

for $option (@{$printer->{'args'}}) {
	$name = $option->{'name'};
	$type = $option->{'type'};
	$default = $option->{'default'};
	$comment = $option->{'comment'};
	$idx = $option->{'idx'};

	print "\t'$name' : {
		'name' : '$name',
		'type' : '$type',
		'default' : '$default',
		'comment' : '$comment',
		'idx' : '$idx',\n";

	if (($type eq 'int') or ($type eq 'float')) {
		$min = $option->{'min'};
		$max = $option->{'max'};
		print "\t\t'min' : '$min',\n\t\t'max' : '$max',\n";
	}

	if ($type eq "enum") {
		print "\t\t'vals' : {\n";
		for $val (@{$option->{'vals'}}) {
			$value = $val->{'value'};
			$comment = $val->{'comment'};
			print "\t\t\t'$value' : {\n\t\t\t\t'value' : '$value',\n" .
				"\t\t\t\t'comment' : '$comment'\n\t\t\t},\n";
		}
		print "\t\t},\n";
	}

	print "\t},\n";
}

print '}';

